#include <windows.h>
#include "cmdlinespy.h"

// This "ThreadProc" returns the process-relative string
// pointer (Ansi or Unicode) to the command line.
//
DWORD WINAPI GetCmdLineA( void * )
{
    return (DWORD)GetCommandLineA();
}

DWORD WINAPI GetCmdLineW( void * )
{
    return (DWORD)GetCommandLineW();
}

DWORD WINAPI GetCmdLineExA( void * )
{
    COMMANDLINEINFO *pcli;
    
    pcli = (COMMANDLINEINFO *)
        VirtualAllocEx( GetCurrentProcess(), 0, sizeof(COMMANDLINEINFO),
                        MEM_RESERVE | MEM_COMMIT, PAGE_READWRITE );

    if( pcli )
    {
        char   *pszCmdLine = GetCommandLineA();
        DWORD   cbPath = (strlen(pszCmdLine) + 1) * sizeof(char);

        pcli->cchPath = strlen(pszCmdLine);
        pcli->pszCmdLine = (TCHAR *)pszCmdLine;
    }

    return (DWORD)pcli;
}

DWORD WINAPI GetCmdLineExW( void * )
{
    COMMANDLINEINFO *pcli;
    
    pcli = (COMMANDLINEINFO *)
        VirtualAllocEx( GetCurrentProcess(), 0, sizeof(COMMANDLINEINFO),
                        MEM_RESERVE | MEM_COMMIT, PAGE_READWRITE );

    if( pcli )
    {
        wchar_t *pszCmdLine = GetCommandLineW();
        DWORD   cbPath = (wcslen(pszCmdLine) + 1) * sizeof(wchar_t);

        pcli->cchPath = wcslen(pszCmdLine);
        pcli->pszCmdLine = (TCHAR *)pszCmdLine;
    }

    return (DWORD)pcli;
}
